blob: b700deaca9ebb8fb86d152c8654c8ce8e8cd748e [file] [log] [blame]
Harald Welte0e6be0e2010-08-25 21:57:59 +02001#!/bin/sh
2### BEGIN INIT INFO
3# Provides: osmo-nitb
4# Required-Start: $network $local_fs
5# Required-Stop:
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: Osmocom GSM network-in-a-box
9# Description: A minimal implementation of the GSM Base Station Controller,
10# Mobile Switching Center, Home Location regster and all other
11# components to run a self-contained GSM network.
12### END INIT INFO
13
14# Author: Harald Welte <laforge@gnumonks.org>
15
16# PATH should only include /usr/* if it runs after the mountnfs.sh script
17PATH=/sbin:/usr/sbin:/bin:/usr/bin
18DESC=osmo-nitb # Introduce a short description here
Eric Butler3d610e62012-08-19 16:06:05 -070019NAME=osmocom-nitb # Introduce the short server's name here
20DAEMON=/usr/bin/osmo-nitb # Introduce the server's location here
Harald Welte0e6be0e2010-08-25 21:57:59 +020021PIDFILE=/var/run/$NAME.pid
22SCRIPTNAME=/etc/init.d/$NAME
23
24# Exit if the package is not installed
25[ -x $DAEMON ] || exit 0
26
27# Read configuration variable file if it is present
28[ -r /etc/default/$NAME ] && . /etc/default/$NAME
29
30# Load the VERBOSE setting and other rcS variables
31. /lib/init/vars.sh
32
33# Define LSB log_* functions.
34# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
35. /lib/lsb/init-functions
36
Eric Butler3d610e62012-08-19 16:06:05 -070037DAEMON_ARGS="$DAEMON_ARGS -D -c $CONFIG_FILE"
Harald Welte0e6be0e2010-08-25 21:57:59 +020038
39#
40# Function that starts the daemon/service
41#
42do_start()
43{
44 # Return
45 # 0 if daemon has been started
46 # 1 if daemon was already running
47 # 2 if daemon could not be started
48 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
49 || return 1
50 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
51 $DAEMON_ARGS \
52 || return 2
53 # Add code here, if necessary, that waits for the process to be ready
54 # to handle requests from services started subsequently which depend
55 # on this one. As a last resort, sleep for some time.
56}
57
58#
59# Function that stops the daemon/service
60#
61do_stop()
62{
63 # Return
64 # 0 if daemon has been stopped
65 # 1 if daemon was already stopped
66 # 2 if daemon could not be stopped
67 # other if a failure occurred
68 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
69 RETVAL="$?"
70 [ "$RETVAL" = 2 ] && return 2
71 # Wait for children to finish too if this is a daemon that forks
72 # and if the daemon is only ever run from this initscript.
73 # If the above conditions are not satisfied then add some other code
74 # that waits for the process to drop all resources that could be
75 # needed by services started subsequently. A last resort is to
76 # sleep for some time.
77 start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
78 [ "$?" = 2 ] && return 2
79 # Many daemons don't delete their pidfiles when they exit.
80 rm -f $PIDFILE
81 return "$RETVAL"
82}
83
84#
85# Function that sends a SIGHUP to the daemon/service
86#
87do_reload() {
88 #
89 # If the daemon can reload its configuration without
90 # restarting (for example, when it is sent a SIGHUP),
91 # then implement that here.
92 #
93 start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
94 return 0
95}
96
97case "$1" in
98 start)
99 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
100 do_start
101 case "$?" in
102 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
103 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
104 esac
105 ;;
106 stop)
107 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
108 do_stop
109 case "$?" in
110 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
111 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
112 esac
113 ;;
114 status)
115 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
116 ;;
117 #reload|force-reload)
118 #
119 # If do_reload() is not implemented then leave this commented out
120 # and leave 'force-reload' as an alias for 'restart'.
121 #
122 #log_daemon_msg "Reloading $DESC" "$NAME"
123 #do_reload
124 #log_end_msg $?
125 #;;
126 restart|force-reload)
127 #
128 # If the "reload" option is implemented then remove the
129 # 'force-reload' alias
130 #
131 log_daemon_msg "Restarting $DESC" "$NAME"
132 do_stop
133 case "$?" in
134 0|1)
135 do_start
136 case "$?" in
137 0) log_end_msg 0 ;;
138 1) log_end_msg 1 ;; # Old process is still running
139 *) log_end_msg 1 ;; # Failed to start
140 esac
141 ;;
142 *)
143 # Failed to stop
144 log_end_msg 1
145 ;;
146 esac
147 ;;
148 *)
149 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
150 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
151 exit 3
152 ;;
153esac
154
155: